/*
 ******************************
 *         Übertragen         *
 *           (c) by           *
 *       Sebastian Krauß      *
 *       Pascal Pfiffner      *
 *            2006            *
 ******************************
 */


/*
 * Define some globals and start
 */
var _version;
var _sections = new Array("options", "accounts", "bonjour", "about");
var _widgetIsVisible;
var accountsNotShowingOnFront = true;
var uploadAccount;
var uploadFiles;

var hoversOverAccount = false;
var hoversOverWidget = false;
var hoverCheckTimeout;

var percentGauge = { centerX:51, centerY: 124, radius:34, min:0, max:1, current:0, animation:{ from:0, to:0}, id:"percentGauge", canvas:null };
var kbsGauge = { centerX:169, centerY: 124, radius:34, min:0, max:6, current:0, animation:{ from:0, to:0}, id:"kbsGauge", canvas:null };
var percentGaugeAnim = { startTime:0, stopTime:0, startValue:0, stopValue:0, animTime:400, timeout:null };
var kbsGaugeAnim = { startTime:0, stopTime:0, startValue:0, stopValue:0, animTime:400, timeout:null };
var currentPercent;

var handImage;
var fadeElementsArray = new Array("percentGaugeBackground", "speedGaugeBackground", "percentGaugeGlass", "speedGaugeGlass")
var blockElementsArray = new Array("cancelButton", "copyFileURIButton");
var bonjourBlockElementsArray = new Array("cancelButton");
var fadeElementsAnim = { startTime:0, stopTime:0, startValue:0, stopValue:0, animTime:400, animationInProgress:false };
var newFileAnim = { startTime:0, stopTime:0, startX:0, stopX:88, startY:0, stopY:49, animTime:300 };
var fileUploadSmallIconSize = 24;
var fileUploadBigIconSize = 48;
var digitImages;
var nextUploadFile;
var uploadWasCancelled;
var speedGaugeShowsKBs;
var isBonjourUpload;
var uri;
var bonjourCompressTransfer = true;
var firstShow = false;
var errorOccurredDuringUpload = false;
var activeUploadAccount;

//var showAccounts;

function init()
{
	createGenericButton(getObj("done"), "done", savePrefs);
	createGenericButton(getObj("errorDivOKButton"), "OK", hideError);
	
	switchPrefTab("options");
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
	}
	speedGaugeShowsKBs = true;
	makeGauge(percentGauge);
	makeGauge(kbsGauge);
	
	_version = getCurrentVersion();
	
	handImage = new Image(68, 68);
	handImage.src = 'Images/pointer.pdf';
	
	digitImages = new Object();
	for (i = 0; i < 10; i++)
	{
		var img = document.createElement("img");
		img.src = "Images/Digits/"+i+".png";
		img.setAttribute("class", "number");
		digitImages[i.toString()] = img;
	}
	var img =  document.createElement("img");
	img.src = "Images/Digits/trans.png";
	img.setAttribute("class", "number");
	digitImages["trans"] = img;
	
	// setup the prefs
	adjustPrefs();
	getObj('idleStatusMessage').style.display = "block";
	
	
	// Testing Code
	
	/*fadeElements(0,1);
	prepareGUIForTransfer();
	displayPercent(24);
	displaySpeed(14.3);
	drawGauge(percentGauge, 30);
	drawGauge(kbsGauge, 77);
	getObj(percentGauge.id).style.display = 'block';
	getObj(kbsGauge.id).style.display = 'block';
	getObj('uploadFileName').innerText="Filename.pdf";	// */
	//showError("This errormessage is a test.");
	//setTimeout("testBonjour();", 1000);
}

function updateIdleStatusMessage()
{
	var numFTP = 0;
	
	for (i = 0; i < allAccounts.length; i++)
	{
		if (allAccounts[i].kind == "FTP") numFTP++;
	}
	
	var statusmessage = numFTP + " FTP account" + (1 != numFTP ? "s" : "") + "<br />";
	
	var numBonjour = FTPUploadPlugin.numberOfBonjourUsers();

	statusmessage += numBonjour + " Widget user" + (1 != numBonjour ? "s" : "");

	getObj('idleStatusMessage').innerHTML = statusmessage;
}

function makeGauge(gauge)
{
	var canv = document.createElement('canvas');
	canv.setAttribute('class', 'gauge');
	var rad = gauge.radius;
	canv.style.height = (rad * 2)+"px";
	canv.style.width = (rad * 2)+"px";
	canv.style.top = (gauge.centerY - rad)+"px";
	canv.style.left = (gauge.centerX - rad)+"px";
	canv.setAttribute('id', gauge.id);
	
	gauge.canvas = canv;
	getObj('front').appendChild(canv);
}

function onShow()
{
	FTPUploadPlugin.setWidgetVisible(true);
	_widgetIsVisible = true;
	
	if ((!firstShow) && (!FTPUploadPlugin.uploadInProgress())) getObj('idleStatusMessage').style.display = "block";
	firstShow = false;
}

function onHide()
{
	FTPUploadPlugin.setWidgetVisible(false);
	_widgetIsVisible = false;
	if (!accountsNotShowingOnFront)
	{
		for (i = 0; i < allAccounts.length; i++)
		{
			var thisDiv = allAccounts[i].frontsideofwidgetcouldntthinkofabettername;
			try {
				getObj('front').removeChild(thisDiv);
			} catch (exception)
			{
			}
		}
		accountsNotShowingOnFront = true;
	}
	
	hideError();
}


/*
 ********************************
 *      DragDrop-functions      *
 ********************************
 */


function dragdrop(event)
{
	if(window.widget) {
		if (FTPUploadPlugin.uploadInProgress()) return;
	}
	if (allAccounts.length == 0) return;
	
	if (null == uploadAccount)
	{
		alert("Oupsie, no upload account. Fix me.");
		return;
	}
	
	var width = 220;
	var height = 180;
	var centerX = width / 2;
	var centerY = height / 2;
	for (i = 0; i < allAccounts.length; i++)
	{
		var anim = allAccounts[i].animation;
		anim.startTransparency = 1;
		anim.finalTransparency = 0;
		if (uploadAccount == allAccounts[i])
		{
			anim.startLeft = anim.finalLeft;
			anim.startTop = anim.finalTop;
			anim.startWidth = anim.finalWidth;
			anim.startHeight = anim.finalHeight;
		} else {
			anim.startLeft = anim.finalLeft;
			anim.startTop = anim.finalTop;
			anim.startWidth = anim.finalWidth;
			anim.startHeight = anim.finalHeight;
			anim.finalLeft = centerX;
			anim.finalTop = centerY;
			anim.finalWidth = 0;
			anim.finalHeight = 0;
		}

		allAccounts[i].animateAt(0);
	}
	
	// Fade out the account divs and remove the timeout
	if (null != hoverCheckTimeout) window.clearTimeout(hoverCheckTimeout);
	hoverCheckTimeout = null;
	hoversOverAccount = false;
	hoversOverWidget = false;
		
	uploadWasCancelled = false;	
	
	animateAccounts();
	setTimeout("removeFrontDivs();", animationTime + 100);
	
	var thisuri = null;
	try {
	    thisuri = event.dataTransfer.getData("text/uri-list");	// attempt to load the URL
	} catch (ex)
	{
	}
	
	uri = thisuri;

	if (undefined == uri)
	{
		showError("An error occurred processing the files.<br />Please try dragging the files from the Finder.");
		return;
	}
		
	event.stopPropagation();
	event.preventDefault();
	
	isBonjourUpload = (uploadAccount.kind != "FTP");
	currentPercent = 0;
	
	if (bonjourCompressTransfer && isBonjourUpload)
	{
		getObj('uploadFileName').innerText = "Compressing";
	} else {
		getObj('uploadFileName').innerText = "Preparing";
	}
	getObj('uploadFileName').style.display = 'block';
	
	if (uri) setTimeout("initiateTransfer();", animationTime + 200);
	
	activeUploadAccount = uploadAccount;
}

function initiateTransfer()
{
	if (uploadAccount.kind == "FTP")
	{
		var pw = uploadAccount.pass;
		var user = uploadAccount.username;
		var host = uploadAccount.host;
		
		if ("" == user)
		{
			showError("No user name specified for account &quot;" + uploadAccount.notation + "&quot;, please supply one", switchToAccountPrefs);
			return;
		}
		if ("" == pw)
		{
			showError("No password specified for account &quot;" + uploadAccount.notation + "&quot;, please specify it", switchToAccountPrefs);
			return;
		}
		if ("" == host)
		{
			showError("No host specified for account &quot;" + uploadAccount.notation + "&quot;, please specify it", switchToAccountPrefs);
			return;
		}
		
		FTPUploadPlugin.prepareUpload(uri, getRemotePathForAccount(uploadAccount), user, pw);
	} else {
		if (!FTPUploadPlugin.prepareBonjourUpload(uri, uploadAccount.notation.replace(/<br \/>/, "\n"), bonjourCompressTransfer))
		{
			showError("An internal plugin error occurred.");
			return;
		}
	}

	var files = FTPUploadPlugin.filesToBeUploaded();
	
	uploadFiles = new Object();
	
	var intericonspace = 86 / (files.length);
	var xoffset = intericonspace / 2;
	
	for (i = files.length-1; i >= 0; i--)
	{
		var thisFile = new Object();
		
		var parent = document.getElementById('front');
		var thisImage = document.createElement('img');
		thisImage.setAttribute('src', "data:image/png;base64,"+FTPUploadPlugin.iconForFile(files[i], fileUploadBigIconSize));
		var thisDiv = document.createElement('div');
		thisDiv.setAttribute('class', 'uploadImage');
		
		thisImage.setAttribute('width', fileUploadSmallIconSize);
		thisImage.setAttribute('height', fileUploadSmallIconSize);
		thisDiv.style.left = 56 + (i * intericonspace) + xoffset;
		thisDiv.style.top = 55;
		
		thisDiv.appendChild(thisImage);
		parent.appendChild(thisDiv);
		thisFile.image = thisDiv;
		thisFile.selfImage = thisImage;
		
		var comps = files[i].split("/");
		thisFile.name = comps[comps.length-1];
		
		uploadFiles[files[i]] = thisFile;
	}
			
	setTimeout("fadeElements(0, 1);", 1);
	setTimeout("prepareGUIForTransfer();", 5 + fadeElementsAnim.animTime);
	if (uploadAccount.kind == "FTP") setTimeout("FTPUploadPlugin.startUpload();", 10 + fadeElementsAnim.animTime);
	else setTimeout("FTPUploadPlugin.startBonjourUpload();", 10 + fadeElementsAnim.animTime);
}
	
function prepareGUIForTransfer()
{
	kbsGauge.max = 6;
	updateScaleMax();

	if (!isBonjourUpload) getObj('uploadFileName').innerText = "";
	else getObj('uploadFileName').innerText = "Connecting";
	
	clearDisplay('uploadFileProgress');
	clearDisplay('uploadKBS');
	getObj('uploadSecondsRemaining').innerText = "";
	drawGauge(percentGauge, 0);
	drawGauge(kbsGauge, 0);
	getObj('uploadFileName').style.display = 'block';
	getObj('uploadFileProgress').style.display = 'block';
	getObj('uploadKBS').style.display = 'block';
	getObj('uploadSecondsRemaining').style.display = 'block';
	getObj(percentGauge.id).style.display = 'block';
	getObj(kbsGauge.id).style.display = 'block';
}

function removeFrontDivs()
{
	for (i = 0; i < allAccounts.length; i++)
	{
		var thisDiv = allAccounts[i].frontsideofwidgetcouldntthinkofabettername;
		try {
			getObj('front').removeChild(thisDiv);
		} catch (ex)
		{
		}
		if (allAccounts[i].kind == "Bonjour") allAccounts.splice(i--, 1);
	}

	accountsNotShowingOnFront = true;
}

function getRemotePathForAccount(account)
{
	var result = "";
	var host = account.host;
	var path = account.path;
	
	if (host.indexOf("ftp://") == 0) result = host;
	else result = "ftp://" + host
	
	if (result.substr(result.length-1, 1) != "/") result += "/";
	
	if (path == "/") path = "";
	
	if (path.length > 0)
	{
		if (path.substr(0,1) == "/") path = path.substr(1, path.length-1);
		result += path;
	}

	if (result.substr(result.length-1, 1) != "/") result += "/";
	
	return result;
}

function copyURLs()
{
	if(window.widget) FTPUploadPlugin.copyRemotePathsToClipboard((activeUploadAccount.httppath == undefined ? "" : activeUploadAccount.httppath), getRemotePathForAccount(activeUploadAccount));
}

function drawGauge(gauge, value)
{
	var gMax = gauge.max;
	if (value > gMax) 
	{
		if (gauge == kbsGauge)
		{
			gMax = value;
			kbsGauge.max = Math.ceil(value);
		} else {
			value = gMax;
		}
	}
	var gMin = gauge.min;
	if (value < gMin) value = gMin;
	
	gauge.current = value;
	
	var fraction = (value - gMin) / (gMax - gMin);
	var radius = gauge.radius;

	var context = gauge.canvas.getContext("2d");
	context.clearRect(0, 0, radius*2, radius*2);

	context.save();
	context.translate(radius, radius);
	//context.rotate(-1.5707963268 + (fraction * 3.1415926));
	//context.rotate(-2.0707963268 + (fraction * 4.1415926));
	context.rotate(-1.9 + (fraction * 3.8));
	context.translate(-radius, -radius);
	
	context.drawImage(handImage, -0, 0);
	
	context.restore();
}

function percentDone(file, thispercent, allpercent)
{
	var thisfile = uploadFiles[file];
	thisfile["image"].style.opacity = 1-thispercent;
	
	var perc = Math.floor(allpercent*100);
	displayPercent(perc);
	var delta = allpercent - currentPercent;
	currentPercent = allpercent;
	if (delta < .02) drawGauge(percentGauge, allpercent);
	else animatePercentGauge(allpercent);
}

function currentKBS(kbs)
{
	var kbsec = Math.floor(kbs*10) / 10;
	displaySpeed(kbsec);
	if (kbs > kbsGauge.max)
	{
		setTimeout("updateScaleMax();", kbsGaugeAnim.animTime + 10);
	}
	animateKBSGauge(kbsec);
}

function animateKBSGauge(val)
{
	if (kbsGaugeAnim.timeout != null) window.clearTimeout(kbsGaugeAnim.timeout);
	if (val == kbsGauge.current) return;
	kbsGaugeAnim.startValue = kbsGauge.current;
	kbsGaugeAnim.stopValue = val;
	
	var now = (new Date()).getTime();
	kbsGaugeAnim.startTime = now;
	kbsGaugeAnim.stopTime = now + kbsGaugeAnim.animTime;
	kbsGaugeAnim.timeout = setTimeout("doAnimateKBSGauge();", 10);
}

function doAnimateKBSGauge()
{
	var now = (new Date()).getTime();
	if (now < kbsGaugeAnim.stopTime)
	{
		var delta = (now - kbsGaugeAnim.startTime) / kbsGaugeAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * kbsGaugeAnim.startValue) + (factor * kbsGaugeAnim.stopValue);
		drawGauge(kbsGauge, value);
		
		kbsGaugeAnim.timeout = setTimeout("doAnimateKBSGauge();", 10);
	} else {
		drawGauge(kbsGauge, kbsGaugeAnim.stopValue);
	}
}

function animatePercentGauge(val)
{
	if (percentGaugeAnim.timeout != null) window.clearTimeout(percentGaugeAnim.timeout);
	if (val == percentGauge.current) return;
	percentGaugeAnim.startValue = percentGauge.current;
	percentGaugeAnim.stopValue = val;
	
	var now = (new Date()).getTime();
	percentGaugeAnim.startTime = now;
	percentGaugeAnim.stopTime = now + percentGaugeAnim.animTime;
	percentGaugeAnim.timeout = setTimeout("doAnimatePercentGauge();", 10);
}

function doAnimatePercentGauge()
{
	var now = (new Date()).getTime();
	if (now < percentGaugeAnim.stopTime)
	{
		var delta = (now - percentGaugeAnim.startTime) / percentGaugeAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * percentGaugeAnim.startValue) + (factor * percentGaugeAnim.stopValue);
		drawGauge(percentGauge, value);
		
		percentGaugeAnim.timeout = setTimeout("doAnimatePercentGauge();", 10);
	} else {
		drawGauge(percentGauge, percentGaugeAnim.stopValue);
	}
}

function fadeElements(from, to)
{
	if (from == 0)
	{
		for (i = 0; i < fadeElementsArray.length; i++)
		{
			getObj(fadeElementsArray[i]).style.display = 'block';
		}
	}
	
	// show blockElementsArray and hide the 'i'-button
	var blockArray = isBonjourUpload ? bonjourBlockElementsArray : blockElementsArray;
	for (i = 0; i < blockArray.length; i++)
	{
		getObj(blockArray[i]).style.display = (from == 0) ? 'block' : 'none';
	}

	getObj('flip').style.display = (from == 0) ? 'none' : 'block';
	
	fadeElementsAnim.startValue = from;
	fadeElementsAnim.stopValue = to;
	fadeElementsAnim.animationInProgress = true;
	
	var now = (new Date()).getTime();
	fadeElementsAnim.startTime = now;
	fadeElementsAnim.stopTime = now + fadeElementsAnim.animTime;
	setTimeout("doFadeElements();", 10);
}

function doFadeElements()
{
	var now = (new Date()).getTime();
	if (now < fadeElementsAnim.stopTime)
	{
		var delta = (now - fadeElementsAnim.startTime) / fadeElementsAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * fadeElementsAnim.startValue) + (factor * fadeElementsAnim.stopValue);
		for (i = 0; i < fadeElementsArray.length; i++)
		{
			getObj(fadeElementsArray[i]).style.opacity = value;
		}
		setTimeout("doFadeElements();", 10);
	} else {
		for (i = 0; i < fadeElementsArray.length; i++)
		{
			getObj(fadeElementsArray[i]).style.opacity = fadeElementsAnim.stopValue;
		}
		if (0 == fadeElementsAnim.stopValue)
		{
			for (i = 0; i < fadeElementsArray.length; i++)
			{
				getObj(fadeElementsArray[i]).style.display = 'none';
			}

		}
		fadeElementsAnim.animationInProgress = false;
	}
}

function secondsRemaining(secs)
{
	if (0 == secs)
	{
		getObj('uploadSecondsRemaining').innerText = "";
		return;
	}
	var minutes = Math.floor(secs/60);
	var seconds = secs % 60;
	getObj('uploadSecondsRemaining').innerText =  minutes + ":" + (seconds < 10 ? "0" : "") + seconds;
}

function directoryDone(dir)
{
	animateDirectory(dir);
}

var directoryAnimation = { startTime:0, stopTime:0, animTime:200 };

function animateDirectory(dir)
{
	var now = (new Date()).getTime();
	directoryAnimation.startTime = now;
	directoryAnimation.stopTime = now + directoryAnimation.animTime;
	setTimeout("doAnimateDirectory(\"" + dir + "\");", 10);
}

function doAnimateDirectory(dir)
{
	var now = (new Date()).getTime();
	if (now < directoryAnimation.stopTime)
	{
		var delta = (now - directoryAnimation.startTime) / directoryAnimation.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		percentDone(dir, factor);
		setTimeout("doAnimateDirectory(\"" + dir + "\");", 10);
	} else {
		fileDone(dir);
	}
}

function updateScaleMax()
{
	return;
	
	getOb('scaleMax').innerText = kbsGauge.max;
}

function prepareUpload(file)
{
	var thisfile = uploadFiles[file];
	var displayname = thisfile["name"];
	if (isBonjourUpload && bonjourCompressTransfer) displayname = "Archive";
	
	if (displayname.length > 12) getObj('uploadFileName').innerHTML = "<marquee scrollamount=\"2\" scrolldelay=\"50\">" + FTPUploadPlugin.escapedString(displayname) + "</marquee>";
	else getObj('uploadFileName').innerText = displayname;
	
	animateKBSGauge(0);
	
	if (_widgetIsVisible) animateNextFile(uploadFiles[file]);
	else {
		nextUploadFile = uploadFiles[file];
		nextUploadFile.image.style.width = fileUploadBigIconSize;
		nextUploadFile.image.style.height = fileUploadBigIconSize;
		nextUploadFile.image.style.top = newFileAnim.stopY;
		nextUploadFile.image.style.left = newFileAnim.stopX;
		nextUploadFile.selfImage.setAttribute('width', fileUploadBigIconSize);
		nextUploadFile.selfImage.setAttribute('height', fileUploadBigIconSize);
	}
}

function fileDone(file)
{
	// remove div for file
	getObj('front').removeChild(uploadFiles[file]["image"]);
	uploadFiles = removeKeyFromHash(file, uploadFiles);
	getObj('uploadFileName').innerText = "";
	clearDisplay('uploadKBS');
	animateKBSGauge(0);
}

function animateNextFile(file)
{
	nextUploadFile = file;
	newFileAnim.startX = parseInt(nextUploadFile.image.style.left);
	newFileAnim.startY = parseInt(nextUploadFile.image.style.top);
	
	var now = (new Date()).getTime();
	newFileAnim.startTime = now;
	newFileAnim.stopTime = now + newFileAnim.animTime;
	setTimeout("doAnimateNextFile();", 10);
}

function doAnimateNextFile()
{
	var now = (new Date()).getTime();
	if (now < newFileAnim.stopTime)
	{
		var delta = (now - newFileAnim.startTime) / newFileAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var valueX = ((1.0-factor) * newFileAnim.startX) + (factor * newFileAnim.stopX);
		var valueY = ((1.0-factor) * newFileAnim.startY) + (factor * newFileAnim.stopY);
		var size = ((1.0-factor) * fileUploadSmallIconSize) + (factor * fileUploadBigIconSize);
		
		nextUploadFile.image.style.width = size;
		nextUploadFile.image.style.height = size;
		nextUploadFile.image.style.top = valueY;
		nextUploadFile.image.style.left = valueX;
		nextUploadFile.selfImage.setAttribute('width', size);
		nextUploadFile.selfImage.setAttribute('height', size);
		
		setTimeout("doAnimateNextFile();", 10);
	} else {
		nextUploadFile.image.style.width = fileUploadBigIconSize;
		nextUploadFile.image.style.height = fileUploadBigIconSize;
		nextUploadFile.image.style.top = newFileAnim.stopY;
		nextUploadFile.image.style.left = newFileAnim.stopX;
		nextUploadFile.selfImage.setAttribute('width', fileUploadBigIconSize);
		nextUploadFile.selfImage.setAttribute('height', fileUploadBigIconSize);
	}
}

function errorOccurred()
{
	var keys = keysFromHash(uploadFiles);

	for (i = 0; i < keys.length; i++)
	{
		var file = uploadFiles[keys[i]];
		getObj('front').removeChild(file["image"]);
		removeKeyFromHash(keys[i], uploadFiles);
	}
	errorOccurredDuringUpload = true;
	uploadDone();

	FTPUploadPlugin.beep();

	showError("An error occurred while uploading.<br />The upload was cancelled.");
	alert("The plugin reports an error. Oops.");
}

function transferRejected()
{
	var keys = keysFromHash(uploadFiles);

	for (i = 0; i < keys.length; i++)
	{
		var file = uploadFiles[keys[i]];
		getObj('front').removeChild(file["image"]);
		removeKeyFromHash(keys[i], uploadFiles);
	}
	errorOccurredDuringUpload = true;
	uploadDone();

	FTPUploadPlugin.beep();

	showError("The receiver rejected the transfer.<br />The transfer was cancelled.");
	//alert("The transfer was rejected.");
}

function showError(errorHTML, errorFunction)
{
	getObj('errorMessage').innerHTML = errorHTML;
	var errbtn = getObj(errorDivOKButton);
	
	if('function' == typeof(errorFunction)) {
		errbtn.setAttribute('genericButtonOnAction', errorFunction);
		errbtn.genericButtonAction = errorFunction;
	}
	else {
		errbtn.setAttribute('genericButtonOnAction', hideError);
		errbtn.genericButtonAction = hideError;
	}
	genericButtonSetEnabled(getObj(errorDivOKButton), 1);
	getObj('errorDiv').style.display = 'block';
}

function hideError() {
	getObj('errorDiv').style.display = 'none';
}

function dragenter (event)
{
	if(window.widget) {
		if (FTPUploadPlugin.uploadInProgress()) return;
	}
	while (fadeElementsAnim.animationInProgress)
	{
		// wait
	}
	if (!accountsNotShowingOnFront) return;
	
	getObj('idleStatusMessage').style.display = "none";

	for (i = 0; i < allAccounts.length; i++)
	{
		if (allAccounts[i].kind == "Bonjour") allAccounts.splice(i--, 1);
	}

	if(window.widget) {
		var bonjourServices = FTPUploadPlugin.availableBonjourServices();
		
		for (i = 0; i < bonjourServices.length; i++)
		{
			new Account(bonjourServices[i], "", "", "", "", "", "Bonjour");
		}
	}

	if (allAccounts.length == 0)
	{
		showError("No accounts configured, please configure one", switchToAccountPrefs);
		return;
	}

	uploadAccount = null;
	if (accountsNotShowingOnFront)
	{
		prepareAccountsForAnimation();
		animateAccounts();
		accountsNotShowingOnFront = false;
	}
	if (null != hoverCheckTimeout) window.clearTimeout(hoverCheckTimeout);
	hoverCheckTimeout = null;
	hoversOverWidget = true;
	hoversOverAccount = true;
	event.stopPropagation();
	event.preventDefault();
}

function uploadDone()
{
	getObj('uploadFileName').style.display = 'none';
	getObj('uploadFileProgress').style.display = 'none';
	getObj('uploadKBS').style.display = 'none';
	getObj('uploadSecondsRemaining').style.display = 'none';
	getObj(percentGauge.id).style.display = 'none';
	getObj(kbsGauge.id).style.display = 'none';
	setTimeout("fadeElements(1,0);", 2);

	if (!uploadWasCancelled)
	{
		if (!errorOccurredDuringUpload) uploadSoundChanged();
		
		if (!errorOccurredDuringUpload) getObj('idleStatusMessage').innerText = "Upload successful";
		else getObj('idleStatusMessage').innerText = "Error";
		
		setTimeout("updateIdleStatusMessage()", 5000);
	} else {
		updateIdleStatusMessage();
	}
	getObj('idleStatusMessage').style.display = "block";
	errorOccurredDuringUpload = false;
}

// prepares the cancel-button for the second definitive click
function askCancelUpload() {
	var image = getObj('cancelButton');
	image.src = "Images/cancelbutton_confirm.png";
	image.setAttribute('onclick', "cancelUpload()");
	image.title = "click again to cancel the upload";
	
	setTimeout("restoreCancelButton()", 5000);
}

// restores the cancel button back to the default state
function restoreCancelButton() {
	var image = getObj('cancelButton');
	image.src = "Images/cancelbutton.png";
	image.setAttribute('onclick', "askCancelUpload()");
	image.title = "cancel upload";
}


function cancelUpload()
{
	if (!FTPUploadPlugin.uploadInProgress()) return;
	FTPUploadPlugin.cancelUpload();
	
	var keys = keysFromHash(uploadFiles);

	for (i = 0; i < keys.length; i++)
	{
		var file = uploadFiles[keys[i]];
		getObj('front').removeChild(file["image"]);
		removeKeyFromHash(keys[i], uploadFiles);
	}
	uploadWasCancelled = true;
	uploadDone();
}

function dragover (event)
{
	if (allAccounts.length == 0) return;
	hoversOverWidget = true;
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event)
{
	hoversOverWidget = false;
	hoverCheckTimeout = window.setTimeout("checkToHideAccounts();", 1000);
	event.stopPropagation();
	event.preventDefault();
}

function checkToHideAccounts()
{
	if (hoversOverAccount || hoversOverWidget) return;
	
	if (null != hoverCheckTimeout) window.clearTimeout(hoverCheckTimeout);
	if(fadeElementsAnim.animationInProgress) {
		hoverCheckTimeout = setTimeout("checkToHideAccounts()", 20);
		return;
	}
	hoverCheckTimeout = null;
	
	var width = 220;
	var height = 180;
	var centerX = width / 2;
	var centerY = height / 2;
	for (i = 0; i < allAccounts.length; i++)
	{
		var anim = allAccounts[i].animation;
		anim.startTransparency = 1;
		anim.finalTransparency = 0;
		anim.startLeft = anim.finalLeft;
		anim.startTop = anim.finalTop;
		anim.startWidth = anim.finalWidth;
		anim.startHeight = anim.finalHeight;
		anim.finalLeft = centerX;
		anim.finalTop = centerY;
		anim.finalWidth = 0;
		anim.finalHeight = 0;

		allAccounts[i].animateAt(0);
	}
	
	animateAccounts();
	setTimeout("removeFrontDivs();", animationTime + 100);
}

function findUserAndPass(host)
{
	if (host.length < 4) return;
	var result = FTPUploadPlugin.authorizationForHost(host);
	if (result.length == 2)
	{
		var form = document.forms['prefform'];
		form.acc_user.value	= result[0];
		form.acc_pass.value = result[1];
	}
}

function prepareAccountsForAnimation()
{
	var numAccounts = allAccounts.length;
	var numColumns = Math.floor(Math.sqrt(numAccounts));
	var numRows = Math.ceil(numAccounts/numColumns);
			
	var width = 220;
	var height = 180;
	var centerX = width / 2;
	var centerY = height / 2;
	
	var interAccountSpacing = 10;
	
	var widthPerAcc = (width / numColumns);
	var heightPerAcc = (height / numRows);
			
	for (i = 0; i < numAccounts; i++)
	{
		var matrixY = Math.floor(i / numColumns);
		var matrixX = i % numColumns;
		
		var finalX = (interAccountSpacing / 2) + (matrixX * widthPerAcc);
		var finalY = (interAccountSpacing / 2) + (matrixY * heightPerAcc);
		
		var thisDiv = allAccounts[i].frontsideofwidgetcouldntthinkofabettername;
		
		thisDiv.setAttribute('class', 'AccountFrontside');
		var anim = allAccounts[i].animation;
		anim.startLeft = centerX;
		anim.startTop = centerY;
		anim.startWidth = 0;
		anim.startHeight = 0;
		anim.finalLeft = finalX;
		anim.finalTop = finalY;
		anim.finalWidth = widthPerAcc - interAccountSpacing;
		anim.finalHeight = heightPerAcc - interAccountSpacing;
		anim.startTransparency = 0;
		anim.finalTransparency = 1;

		allAccounts[i].animateAt(0);
		
		getObj('front').appendChild(thisDiv);
	}
}

var animationStart;
var animationStop;
var animationTime = 400;

function animateAccounts()
{
	// set animation-variables
	var now = (new Date()).getTime();
	animationStart = now;
	animationStop = animationStart + animationTime;
	setTimeout("doAnimateAccounts();", 10);
}

function doAnimateAccounts()
{
	var now = (new Date()).getTime();
	if (now < animationStop)
	{
		var delta = (now - animationStart) / animationTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);

		for (i = 0; i < allAccounts.length; i++)
		{
			allAccounts[i].animateAt(factor);
		}
		setTimeout("doAnimateAccounts();", 10);
	} else {
		for (i = 0; i < allAccounts.length; i++)
		{
			allAccounts[i].animateAt(1);
		}
	}
}


/*
 ****************************
 *      Pref-functions      *
 ****************************
 */


function showPrefs()
{
	var front = getObj("front");
	var back = getObj("back");
	
	for (i = 0; i < allAccounts.length; i++)
	{
		if (allAccounts[i].kind == "Bonjour") allAccounts.splice(i--, 1);
	}

	
	//adjustPrefs();				// adjusts the prefs
	showVersion(_version);		// sets version-number
	
	if(window.widget) {
		window.resizeTo(250, 280);
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display = "none";
	back.style.display = "block";
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}


// adjusts the prefs and sets important variables
function adjustPrefs() {
	loadAccounts();
	if(window.widget) FTPUploadPlugin.setWidgetVisible(true);
	_widgetIsVisible = true;
	
	loadSoundDropdown();
	
	if(window.widget) {
		FTPUploadPlugin.setCanSendToSelf(false);
		//FTPUploadPlugin.setCanSendToSelf(true);
		
		// bonjourDownloadTarget
		var enableBJ = widget.preferenceForKey('enableBonjourSend');
		if ("1" == enableBJ)
		{
			getObj('enableBonjourSend').checked = true;
			FTPUploadPlugin.setEnableBounjourSend(enableBJ);
		} else {
			// Give it five seconds to scan
			// If it finds nothing, display the standard message
			// (with 0 Bonjour clients in that case)
			setTimeout("updateIdleStatusMessage();", 5000);
		}

		var askAcceptEachTransfer = widget.preferenceForKey('bonjourAskReceive');
		askAcceptEachTransfer = ("0" != askAcceptEachTransfer); // catches "1" and undefined
		getObj('bonjourAskReceive').checked = askAcceptEachTransfer;
		FTPUploadPlugin.setAskToAcceptIncomingTransfer(askAcceptEachTransfer);

		var compressBJ = widget.preferenceForKey('bonjourCompress');
		if (("1" == compressBJ) || (undefined == compressBJ))
		{
			getObj('bonjourCompress').checked = true;
			bonjourCompressTransfer = true;
		} else {
			getObj('bonjourCompress').checked = false;
			bonjourCompressTransfer = false;
		}
		var dlTarget = widget.preferenceForKey('bonjourDownloadTarget');
		if (null != dlTarget)
		{
			selectValue(getObj('bonjourDownloadTarget'), dlTarget);
			FTPUploadPlugin.setBonjourDownloadTarget(dlTarget);
			//alert ("dltarget " + dlTarget);
		}
	}
	
	toggleDisabledIfChecked('enableBonjourSend', 'bonjourAskReceive');
}


// loads the sound-dropdown-menu
function loadSoundDropdown() {
	var selector = getObj('uploadSound');
	
	if(window.widget) {
		var alarmSound = widget.preferenceForKey("uploadSound");
		var sounds = FTPUploadPlugin.validSounds();
		var currentLibrary = 0;
		
		var hasNewOptions = has1043Features();
		
		// add sounds to the drop-down
		for(i = 0; i < sounds.length; i++) {
			var components = sounds[i].split("/");
			
			// new library; add separator
			var separator;
			
			if(currentLibrary != components[1]) {
				if(hasNewOptions)
					separator = document.createElement("hr");
				else {
					separator = document.createElement("option");
					separator.value = '';
					separator.innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
				}
				selector.appendChild(separator);
			}
			
			// add new sound-option
			soundname = components[components.length - 1];
			soundname = soundname.substring(0, soundname.indexOf(".", soundname.length - 6));
			
			var newoption = document.createElement("option");
			newoption.value = sounds[i];
			newoption.innerHTML = (soundname.length > 0) ? soundname : "Systemsound";
			newoption.selected = (sounds[i] == alarmSound);
			selector.appendChild(newoption);
			
			currentLibrary = components[1];
		}
	}
	else {
		selector.disabled = true;
	}
}


function switchPrefTab(tab)
{
	var found = false;
	var thedivs = _sections ? _sections : new Array();
	
	for(var i = 0; i < thedivs.length; i++) {
		if(tab == thedivs[i]) {
			getObj("tab_" + thedivs[i]).setAttribute("class", "tabitem selected");
			getObj("prefs_" + thedivs[i]).style.display = "block";
			found = true;
		}
		else {
			getObj("tab_" + thedivs[i]).setAttribute("class", "tabitem");
			getObj("prefs_" + thedivs[i]).style.display = "none";
		}
	}
	
	if(!found) {
		getObj("prefs_about").style.display = "block";
	}
}

// switches to the account-tab (used in most errordialogues)
function switchToAccountPrefs() {
	switchPrefTab('accounts');
	showPrefs();
}

// switches to the Bonjour Help Text
function switchToBonjourHelp() {
	switchPrefTab('about');
	var div = getObj('helpdiv');
	var anchor = getObj('bonjour_help');
	div.scrollTop = anchor.offsetTop;
}



// sheet animation

var sheetAnim = { obj:null, start:null, stop:null, time:300, to:0, size:0 }
function showSheet(id)
{
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	// set animation-variables
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = parseInt(document.defaultView.getComputedStyle(obj, null).getPropertyValue('height')) + 10;
	
	if(sheetAnim.to != sheetAnim.size)
		setTimeout("animateSheet();", 10);
}

function animateSheet()
{
	var now = (new Date()).getTime();
	if (now < sheetAnim.stop)
	{
		var delta = (now - sheetAnim.start) / sheetAnim.time;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (sheetAnim.to < 1) ? (sheetAnim.size - (sheetAnim.size * factor)) : (sheetAnim.to * factor);

		sheetAnim.obj.style.height = size + "px";
		
		setTimeout("animateSheet();", 10);
	} else {
		sheetAnim.obj.style.height = sheetAnim.to + "px";
		sheetAnim.size = sheetAnim.to;
		sheetAnim.obj = null;
	}
}

function hideSheet(id)
{
	if(sheetAnim.to == 0) return;
	
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = 0;
	setTimeout("animateSheet();", 10);
}


// Account saving
var loadedAccount = null;

function showAccountForm() {
	var form = document.forms['prefform'];
	if(loadedAccount) {
		form.acc_notation.value = loadedAccount.notation;
		form.acc_user.value = loadedAccount.username;
		form.acc_pass.value = loadedAccount.pass == "" ? "" : '********';
		form.acc_host.value = loadedAccount.host;
		form.acc_path.value = loadedAccount.path;
		form.acc_httppath.value = loadedAccount.httppath;
	}
	form.acc_notation.focus();
	
	showSheet("accountFormInner");
}

function saveAccount() {
	if(loadedAccount) {					// an existing account was altered, save the new values
		loadedAccount.saveNewValues();
	}
	else {								// save a new account
		var form = document.forms['prefform'];
		new Account(form.acc_notation.value, form.acc_user.value, form.acc_host.value, form.acc_path.value, form.acc_httppath.value, form.acc_pass.value, "FTP");
	}
	hideAccountForm();
}

function hideAccountForm() {
	// hide it
	hideSheet("accountFormInner");
	
	// clean it up
	var form = document.forms['prefform'];
	form.acc_notation.value = '';
	form.acc_user.value = '';
	form.acc_pass.value = '';
	form.acc_host.value = '';
	form.acc_path.value = '';
	form.acc_httppath.value = '';
	loadedAccount = null;
}


function savePrefs() {
	var prefform = getObj('prefform');
		
	// save all
	if(window.widget) {
		saveAccounts();
			
		var enableBJ = getObj('enableBonjourSend').checked ? "1" : "0";
		widget.setPreferenceForKey(enableBJ, "enableBonjourSend");
		FTPUploadPlugin.setEnableBounjourSend(enableBJ);
		var compressBJ = getObj('bonjourCompress').checked ? "1" : "0";
		widget.setPreferenceForKey(compressBJ, "bonjourCompress");
		var askAcceptEachTransfer = getObj('bonjourAskReceive').checked ? "1" : "0";
		widget.setPreferenceForKey(askAcceptEachTransfer, "bonjourAskReceive");
		FTPUploadPlugin.setAskToAcceptIncomingTransfer("1" == askAcceptEachTransfer);
		bonjourCompressTransfer = ("1" == compressBJ ? true : false);
		if (enableBJ)
		{
			var dlTarget = widget.preferenceForKey('bonjourDownloadTarget');
			if (null != dlTarget)
			{
				FTPUploadPlugin.setBonjourDownloadTarget(dlTarget);
			}
		}
	}
	
	hidePrefs();
	if (window.widget && !FTPUploadPlugin.uploadInProgress()) updateIdleStatusMessage();
}


function hidePrefs() {
	var front = getObj("front");
	var back = getObj("back");
	hideError();
	
	if(window.widget) {
		widget.prepareForTransition("ToFront");
		window.resizeTo(220, 180);
	}
	
	front.style.display = "block";
	back.style.display = "none";
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}

function getAccountByDiv(div)
{
	for (i = 0; i < allAccounts.length; i++) {
		if (div == allAccounts[i].div) return allAccounts[i];
	}
	return null;
}

function getAccountByFrontside(div)
{
	for (i = 0; i < allAccounts.length; i++) {
		if (div == allAccounts[i].frontsideofwidgetcouldntthinkofabettername) return allAccounts[i];
	}
	return null;
}

function loadAccounts()
{
	var loadedAcc;
	if(window.widget)
		loadedAcc = widget.preferenceForKey("Accounts");
	if (!loadedAcc) return;
	
	var accounts = Deserialize(loadedAcc);
	
	for (i = 0; i < accounts.length; i++)
	{
		var tmp = accounts[i];
		var host = tmp["host"];
		var notation = tmp["notation"];
		var path = tmp["path"];
		var httppath = tmp["httppath"];
		var pass = "";
		var user = "";
		
		if (host.length > 4)
		{
			var result = FTPUploadPlugin.authorizationForHost(host);
			if (result.length == 2)
			{
				user = result[0];
				pass = result[1];
			}
		}

		new Account(notation, user, host, path, httppath, pass, "FTP");
	}
}

function saveAccounts()
{
	var saveAcc = new Array();
	for (i = 0; i < allAccounts.length; i++)
	{
		var acc = allAccounts[i];
		var tempAcc = new Object();
		tempAcc["notation"] = acc.notation;
		tempAcc["host"] = acc.host;
		tempAcc["path"] = acc.path;
		tempAcc["httppath"] = acc.httppath;
		saveAcc.push(tempAcc);
	}
	if(window.widget) {
		widget.setPreferenceForKey(Serialize(saveAcc), "Accounts");
		//alert("accounts saved.");
	}
}



// *******************
// The Account - Class
var allAccounts = new Array();

function Account(not, name, host, path, httppath, pass, kind) {
	if(!(this instanceof Account))
		return new Account();
	
	// the properties
	this.notation = not ? not.replace(/\n/, "<br />") : 'Account';
	this.username = name ? name : '';
	this.host = host ? host : '';
	this.path = path ? path : '';
	this.httppath = httppath ? httppath : '';
	this.pass = pass ? pass : '';
	
	this.kind = kind ? kind : 'FTP';
	
	// put this element onto our stack
	allAccounts.push(this);
	
	// methods
	this.setNotation = function(not) {
		this.notation = not;
		
		this.div.innerText = not;
		var delknob = document.createElement('img');
		delknob.setAttribute('class', 'delknob');
		delknob.setAttribute('src', 'Images/cross.png');
		delknob.setAttribute('onclick', "getAccountByDiv(this.parentNode).deleteAccount()");
		this.div.appendChild(delknob);
		
		this.frontsideofwidgetcouldntthinkofabettername.titleOfFront.innerHTML = not;
	}
	
	this.setUsername = function(name) {
		this.username = name;
	}
	
	this.setPassword = function(pass) {
		this.pass = pass;
	}
	
	this.setPath = function(path) {
		this.path = path;
	}
	
	this.setHTTPPath = function(httppath) {
		if("/" != httppath.substr(httppath.length-1, 1))
			httppath += "/";
		if(httppath && (httppath.length > 8))
			this.httppath = httppath;
	}
	
	this.selectUploadAccount = function(event) {
		uploadAccount = this;
	}
	
	// Drag events
	this.dragenter = function(event) {
		//alert("this dragenter");
		var hoverclass = ("FTP" == this.kind) ? 'hover_ftp' : 'hover_bonjour';
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside ' + hoverclass);
		hoversOverAccount = true;
		hoversOverWidget = true;
		if (null != hoverCheckTimeout) window.clearTimeout(hoverCheckTimeout);
		hoverCheckTimeout = null;
		event.stopPropagation();
		event.preventDefault();
	}
	
	this.dragleave = function(event) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside');
		hoversOverAccount = false;
		hoverCheckTimeout = window.setTimeout("checkToHideAccounts();", 1000);
		event.stopPropagation();
		event.preventDefault();
	}
	
	// used for the sheet on the backside
	this.loadAccountDetails = function() {
		loadedAccount = this;
		showAccountForm();
	}
	
	this.saveValues = function() {
		if(window.widget) {
			//saveAccounts();
		}
	}
	
	this.saveNewValues = function() {
		var form = document.forms['prefform'];
		this.setNotation(form.acc_notation.value);
		this.setUsername(form.acc_user.value);
		this.setPassword(form.acc_pass.value);
		this.host = form.acc_host.value;
		this.setPath(form.acc_path.value);
		this.setHTTPPath(form.acc_httppath.value);
		
		this.saveValues();
	}
	
	this.getArrayIndex = function() {
		var index = -1;
		if(allAccounts.length > 0) {
			for(var i = 0; i < allAccounts.length; i++) {
				if(this == allAccounts[i]) {
					index = i;
					break;
				}
			}
		}
		return index;
	}
	
	this.deleteAccount = function() {
		var index = this.getArrayIndex();
		
		// delete instance
		this.parent.removeChild(this.div);
		
		// delete from array
		if(-1 < index) {
			allAccounts.splice(index, 1);
			
			return true;
		}
		else
			return false;
	}
	
	this.animation = { startLeft:0, startTop:0, startWidth:0, startHeight:0, finalLeft:0, finalTop:0, finalWidth:0, finalHeight:0, startTransparency:0, finalTransparency:0 };

	this.animateAt = function(delta)
	{
		var height = (delta * this.animation.finalHeight) + ((1-delta) * this.animation.startHeight);
		this.frontsideofwidgetcouldntthinkofabettername.style.left = (delta * this.animation.finalLeft) + ((1-delta) * this.animation.startLeft);
		this.frontsideofwidgetcouldntthinkofabettername.style.top = (delta * this.animation.finalTop) + ((1-delta) * this.animation.startTop);
		this.frontsideofwidgetcouldntthinkofabettername.style.width = (delta * this.animation.finalWidth) + ((1-delta) * this.animation.startWidth);
		this.frontsideofwidgetcouldntthinkofabettername.style.height = height + 'px';
		this.frontsideofwidgetcouldntthinkofabettername.style.opacity = (delta * this.animation.finalTransparency) + ((1-delta) * this.animation.startTransparency);
		//this.frontsideofwidgetcouldntthinkofabettername.style.lineHeight = 0.9 * height + 'px';
	}
	
	// account representation in the prefs (FTP only)
	if("FTP" == this.kind) {
		this.parent = getObj('accountList');
		this.div = document.createElement('div');
		this.div.setAttribute('class', 'Account');
		this.div.setAttribute('onclick', "getAccountByDiv(this).loadAccountDetails()");
		this.div.innerText = this.notation;
		
		var delknob = document.createElement('img');
		delknob.setAttribute('class', 'delknob');
		delknob.setAttribute('src', 'Images/cross.png');
		delknob.setAttribute('onclick', "getAccountByDiv(this.parentNode).deleteAccount()");
		this.div.appendChild(delknob);
		if(this.parent)
			this.parent.appendChild(this.div);
	}
	
	// frontside account representation
	this.frontsideofwidgetcouldntthinkofabettername = document.createElement('div');
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside');
	if("FTP" != this.kind) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('style', 'background-image:url(Images/Bonjour_Tag.png)');
	}
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondrop', "getAccountByFrontside(this).selectUploadAccount(event)");
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondragover', "getAccountByFrontside(this).dragenter(event)");
	//this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondragenter', "getAccountByFrontside(this).dragenter(event)");
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondragleave', "getAccountByFrontside(this).dragleave(event)");
	this.frontsideofwidgetcouldntthinkofabettername.titleOfFront = document.createElement('p');
	this.frontsideofwidgetcouldntthinkofabettername.titleOfFront.innerHTML = not;
	this.frontsideofwidgetcouldntthinkofabettername.appendChild(this.frontsideofwidgetcouldntthinkofabettername.titleOfFront);
	
	if(this.kind == "FTP")
		this.saveValues();
	
	return this;
}






function bonjourDownloadTargetChanged()
{
	var opt = document.getElementById("bonjourDownloadTarget");
	var optval = opt.options[opt.selectedIndex].value;
	FTPUploadPlugin.setBonjourDownloadTarget(optval);
	if (window.widget) widget.setPreferenceForKey(optval, "bonjourDownloadTarget");
}

function uploadSoundChanged()
{
	var opt = document.getElementById("uploadSound");
	var optval = opt.options[opt.selectedIndex].value;
	
	if (window.widget) widget.setPreferenceForKey(optval, "uploadSound");
	
	// default alert-sound chosen; play it
	if(!optval) {
		FTPUploadPlugin.beep();
		return;
	}
	
	// play the chosen alarm-sound
	if(document.getElementById("currentAlertSoundEmbed"))
		document.removeChild(document.getElementById("currentAlertSoundEmbed"));
	
	var soundPlayer = document.createElement("embed");
	soundPlayer.setAttribute("id", "currentAlertSoundEmbed");
	soundPlayer.setAttribute("src", optval);
	soundPlayer.setAttribute("autostart", "false");
	soundPlayer.setAttribute("hidden", "true");
	soundPlayer.setAttribute("enablejavascript", true);
	document.appendChild(soundPlayer);
	
	soundPlayer.Play();
}

function has1043Features() {
	var version = navigator.appVersion;
	var regExp = /.+AppleWebKit\/([\d\.]+).+/;
	var result = regExp.exec(version);
	
	return (parseFloat(result[1]) >= 416.11);
}


/*
 **************
 *  by Apple  *
 **************
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}


